MorethurQuickUse_BagNo = {};
MorethurQuickUse_SlotNo = {};
MorethurQuickUse_ItemQuantity = {};

MorethurQuickUse_ItemCount = 0;
BINDING_HEADER_MORETHURQUICKUSEHEADER = "MorethurQuickUse";

function MQU_initialize()
	-- add our very first chat command!
	SlashCmdList["MQU"] = MQU_command;
	SLASH_MQU1 = "/mqu";

	DEFAULT_CHAT_FRAME:AddMessage("MorethurQuickUse Loaded");
	
	MorethurQuickUseTitle:SetText("QuickUse");	
	
	MQU_HideButtons();

	MQU_UpdateButtons();

	--this:Show()
end

function MQU_command(msg)
	-- this function handles our chat command
	--message(msg);
end

function MQU_HideButtons()
	for i = 1, 30, 1 do
		local button = getglobal("MorethurQuickUseButton" .. i);
		button:SetAttribute("item", "");
		button:Hide();
	end
end


function MQU_ShowButtonTooltip(self)
	--GameTooltip:SetOwner( this, "ANCHOR_BOTTOM" );  -- Tooltip by button
	GameTooltip_SetDefaultAnchor(GameTooltip, self);  -- Tooltip bottom right
	
	GameTooltip:SetBagItem( MorethurQuickUse_BagNo[self:GetID()], MorethurQuickUse_SlotNo[self:GetID()]);
	
end

function MQU_HideButtonTooltip()
	GameTooltip:Hide();
end


function MQU_UpdateButtons()

	MQU_ScanInventory();

	for i = 1, 30, 1 do
		local button = getglobal("MorethurQuickUseButton" .. i);

		if not InCombatLockdown() then
			if i <= MorethurQuickUse_ItemCount then
				button:Show();
				--DEFAULT_CHAT_FRAME:AddMessage("Show button " .. i .. "\n");
			else
				button:Hide();
			end
		end
	end
end



function MQU_ScanInventory()

	--DEFAULT_CHAT_FRAME:AddMessage(" -Scanning inventory");
	local bag = 0;
	local slot = 0;
	
	MorethurQuickUse_ItemCount = 0;
	
	MQU_ClearItemQuantities();
	
    for bag=4, 0, -1 do
		local size = GetContainerNumSlots(bag);
		if (size > 0) then
			for slot=1, size, 1 do
			
				--local itemName, itemLink, itemRarity, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc  = GetContainerItemInfo(checkbag, checkslot);
				local texture, itemCount = GetContainerItemInfo(bag, slot);
				if (itemCount) then
					local link = GetContainerItemLink(bag, slot);
					
					--From KC_Items
						local _,_, code = strfind(link, "(%d+):")
					
					local itemName, itemLink, itemRarity, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc  = GetItemInfo(code);
							--DEFAULT_CHAT_FRAME:AddMessage("itemName: " .. itemName);
							--DEFAULT_CHAT_FRAME:AddMessage("itemLink: " .. itemLink);
							--DEFAULT_CHAT_FRAME:AddMessage("itemRarity: " .. itemRarity);
							--DEFAULT_CHAT_FRAME:AddMessage("itemMinLevel: " .. itemMinLevel);
							--DEFAULT_CHAT_FRAME:AddMessage("itemType: " .. itemType);

							--DEFAULT_CHAT_FRAME:AddMessage("itemStackCount: " .. itemStackCount);
							--DEFAULT_CHAT_FRAME:AddMessage("itemEquipLoc: " .. itemEquipLoc);
							--DEFAULT_CHAT_FRAME:AddMessage(itemName .. " is consumable!");
							--DEFAULT_CHAT_FRAME:AddMessage("itemSubType: " .. itemSubType .. "\n");

					if (itemType and itemName) then  -- Prevent "nil" errors
						if ( (itemSubType == "Consumable" 
							  --or string.find(itemName, "Bandage")
							  or itemSubType == "Consommable"
							  or itemSubType == "Verbrauchbar" 
							  --or string.find(itemName, "Verband")
							) ) then


							-- Check if there already is a button, if so just change the item count on it
							local itemIndex = MQU_GetIndex(itemName);
							--DEFAULT_CHAT_FRAME:AddMessage("itemIndex is " .. itemIndex);
							
							if (itemIndex == -1 or MorethurQuickUse_ItemQuantity[itemIndex] == 0) then
								-- Create new button
								if (MorethurQuickUse_ItemCount < 30) then
									MorethurQuickUse_ItemCount = MorethurQuickUse_ItemCount + 1;
									MorethurQuickUse_BagNo[MorethurQuickUse_ItemCount] = bag;
									MorethurQuickUse_SlotNo[MorethurQuickUse_ItemCount] = slot;
									MorethurQuickUse_ItemQuantity[MorethurQuickUse_ItemCount] = MorethurQuickUse_ItemQuantity[MorethurQuickUse_ItemCount] + itemCount;
									
									local button = getglobal("MorethurQuickUseButton" .. MorethurQuickUse_ItemCount);					
									local buttonText = getglobal("MorethurQuickUseButton" .. MorethurQuickUse_ItemCount .. "Text");					
									local cooldown = getglobal("MorethurQuickUseButton" .. MorethurQuickUse_ItemCount .. "Cooldown");
									local start, duration, enable = GetContainerItemCooldown(bag, slot);
									
									-- * is wildcard for mousebutton number, i.e. all buttons give same result
									-- Button must register for clicks for desired mouse buttons
									
									if not InCombatLockdown() then
										button:SetAttribute("type1", "item"); 
										button:SetAttribute("type2", "item"); 
										button:SetAttribute("item", itemName);
										--button:SetAttribute("bag", bag);
										--button:SetAttribute("slot", slot);
									end
									
									CooldownFrame_SetTimer(cooldown, start, duration, enable);
									
									button:SetNormalTexture(texture);
									buttonText:SetText(MorethurQuickUse_ItemQuantity[MorethurQuickUse_ItemCount]);
								end
							else 
								if (itemIndex ~= -1) then
									local buttonText = getglobal("MorethurQuickUseButton" .. itemIndex .. "Text");
									MorethurQuickUse_ItemQuantity[itemIndex] = MorethurQuickUse_ItemQuantity[itemIndex] + itemCount;
									buttonText:SetText(MorethurQuickUse_ItemQuantity[itemIndex]);
									--DEFAULT_CHAT_FRAME:AddMessage("MorethurQuickUse_ItemQuantity[itemIndex] is " .. MorethurQuickUse_ItemQuantity[itemIndex]);
								end
							end
						end
					end
				end
			end
		end
	end

	--DEFAULT_CHAT_FRAME:AddMessage("Found " .. MorethurQuickUse_ItemCount .. " counsumable items\n");
end

function MQU_UseItem(no)
	DEFAULT_CHAT_FRAME:AddMessage("Button " .. no .. " clicked!");
	
	local command = "/use " .. MorethurQuickUse_BagNo[no] .. " " .. MorethurQuickUse_SlotNo[no];
	DEFAULT_CHAT_FRAME:AddMessage(command);

	--SendChatMessage("/dance");

	UseContainerItem(MorethurQuickUse_BagNo[no], MorethurQuickUse_SlotNo[no]);
	MQU_UpdateButtons();
end



-- On Drag Start event
function MQU_OnDragStart(self)
		self:StartMoving();
end

-- On Drag Stop event
function MQU_OnDragStop(self)
		self:StopMovingOrSizing();
end


function MQU_Toggle()

	if not MorethurQuickUseTop:IsVisible() then
		MorethurQuickUseTop:Show();
		MQU_UpdateButtons();
	else
		MorethurQuickUseTop:Hide();
	end

end

function MQU_OnButtonUpdate(self)
		if ( GameTooltip:IsOwned(self) ) then
		MQU_ShowButtonTooltip(self);
	end
end


function MQU_GetIndex(item)
	result = -1;
	
	for i = 1, 30, 1 do
		local button = getglobal("MorethurQuickUseButton" .. i);
		
		if (button:GetAttribute("item") == item) then
			result = i;
			--DEFAULT_CHAT_FRAME:AddMessage("button " .. i .. " has item " .. button:GetAttribute("item"));
		end
		
	end
	
	return result;
end

function MQU_ClearItemQuantities()
	result = -1;
	
	for i = 1, 30, 1 do
		MorethurQuickUse_ItemQuantity[i] = 0;
	end
	
	return result;
end
